package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.HotelDAO;
import com.rjconsultores.ventaboletos.entidad.Hotel;
import com.rjconsultores.ventaboletos.service.HotelService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("hotelService")
public class HotelServiceImpl implements HotelService {

    @Autowired
    private HotelDAO hotelDAO;

    public List<Hotel> obtenerTodos() {
        return hotelDAO.obtenerTodos();
    }

    public Hotel obtenerID(Integer id) {
        return hotelDAO.obtenerID(id);
    }

    @Transactional
    public Hotel suscribir(Hotel entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return hotelDAO.suscribir(entidad);
    }

    @Transactional
    public Hotel actualizacion(Hotel entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return hotelDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Hotel entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        hotelDAO.actualizacion(entidad);
    }

    public List<Hotel> buscar(String deschotel) {
        return hotelDAO.buscar(deschotel);
    }
}
